// Code generated by go-swagger; DO NOT EDIT.

package global_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"fmt"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// UpdateGlobalServiceTrafficReader is a Reader for the UpdateGlobalServiceTraffic structure.
type UpdateGlobalServiceTrafficReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateGlobalServiceTrafficReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateGlobalServiceTrafficOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewUpdateGlobalServiceTrafficOK creates a UpdateGlobalServiceTrafficOK with default headers values
func NewUpdateGlobalServiceTrafficOK() *UpdateGlobalServiceTrafficOK {
	return &UpdateGlobalServiceTrafficOK{}
}

/* UpdateGlobalServiceTrafficOK describes a response with status code 200, with default header values.

successfully updated service traffic
*/
type UpdateGlobalServiceTrafficOK struct {
}

func (o *UpdateGlobalServiceTrafficOK) Error() string {
	return fmt.Sprintf("[PATCH /api/functions/{serviceName}][%d] updateGlobalServiceTrafficOK ", 200)
}

func (o *UpdateGlobalServiceTrafficOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

/*UpdateGlobalServiceTrafficBody update global service traffic body
// Example: {"values":[{"percent":60,"revision":"global-fast-request-00002"},{"percent":40,"revision":"global-fast-request-00001"}]}
swagger:model UpdateGlobalServiceTrafficBody
*/
type UpdateGlobalServiceTrafficBody struct {

	// List of revision traffic targets
	// Required: true
	Values []*UpdateGlobalServiceTrafficParamsBodyValuesItems0 `json:"values"`
}

// Validate validates this update global service traffic body
func (o *UpdateGlobalServiceTrafficBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateValues(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *UpdateGlobalServiceTrafficBody) validateValues(formats strfmt.Registry) error {

	if err := validate.Required("Service Traffic"+"."+"values", "body", o.Values); err != nil {
		return err
	}

	for i := 0; i < len(o.Values); i++ {
		if swag.IsZero(o.Values[i]) { // not required
			continue
		}

		if o.Values[i] != nil {
			if err := o.Values[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("Service Traffic" + "." + "values" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("Service Traffic" + "." + "values" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// ContextValidate validate this update global service traffic body based on the context it is used
func (o *UpdateGlobalServiceTrafficBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := o.contextValidateValues(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *UpdateGlobalServiceTrafficBody) contextValidateValues(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(o.Values); i++ {

		if o.Values[i] != nil {
			if err := o.Values[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("Service Traffic" + "." + "values" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("Service Traffic" + "." + "values" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (o *UpdateGlobalServiceTrafficBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *UpdateGlobalServiceTrafficBody) UnmarshalBinary(b []byte) error {
	var res UpdateGlobalServiceTrafficBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*UpdateGlobalServiceTrafficParamsBodyValuesItems0 update global service traffic params body values items0
swagger:model UpdateGlobalServiceTrafficParamsBodyValuesItems0
*/
type UpdateGlobalServiceTrafficParamsBodyValuesItems0 struct {

	// Target traffice percentage
	Percent int64 `json:"percent,omitempty"`

	// Target service revision
	Revision string `json:"revision,omitempty"`
}

// Validate validates this update global service traffic params body values items0
func (o *UpdateGlobalServiceTrafficParamsBodyValuesItems0) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this update global service traffic params body values items0 based on context it is used
func (o *UpdateGlobalServiceTrafficParamsBodyValuesItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (o *UpdateGlobalServiceTrafficParamsBodyValuesItems0) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *UpdateGlobalServiceTrafficParamsBodyValuesItems0) UnmarshalBinary(b []byte) error {
	var res UpdateGlobalServiceTrafficParamsBodyValuesItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
