// Code generated by go-swagger; DO NOT EDIT.

package instances

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewCancelInstanceParams creates a new CancelInstanceParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCancelInstanceParams() *CancelInstanceParams {
	return &CancelInstanceParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCancelInstanceParamsWithTimeout creates a new CancelInstanceParams object
// with the ability to set a timeout on a request.
func NewCancelInstanceParamsWithTimeout(timeout time.Duration) *CancelInstanceParams {
	return &CancelInstanceParams{
		timeout: timeout,
	}
}

// NewCancelInstanceParamsWithContext creates a new CancelInstanceParams object
// with the ability to set a context for a request.
func NewCancelInstanceParamsWithContext(ctx context.Context) *CancelInstanceParams {
	return &CancelInstanceParams{
		Context: ctx,
	}
}

// NewCancelInstanceParamsWithHTTPClient creates a new CancelInstanceParams object
// with the ability to set a custom HTTPClient for a request.
func NewCancelInstanceParamsWithHTTPClient(client *http.Client) *CancelInstanceParams {
	return &CancelInstanceParams{
		HTTPClient: client,
	}
}

/* CancelInstanceParams contains all the parameters to send to the API endpoint
   for the cancel instance operation.

   Typically these are written to a http.Request.
*/
type CancelInstanceParams struct {

	/* Instance.

	   target instance
	*/
	Instance string

	/* Namespace.

	   target namespace
	*/
	Namespace string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the cancel instance params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CancelInstanceParams) WithDefaults() *CancelInstanceParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the cancel instance params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CancelInstanceParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the cancel instance params
func (o *CancelInstanceParams) WithTimeout(timeout time.Duration) *CancelInstanceParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the cancel instance params
func (o *CancelInstanceParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the cancel instance params
func (o *CancelInstanceParams) WithContext(ctx context.Context) *CancelInstanceParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the cancel instance params
func (o *CancelInstanceParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the cancel instance params
func (o *CancelInstanceParams) WithHTTPClient(client *http.Client) *CancelInstanceParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the cancel instance params
func (o *CancelInstanceParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInstance adds the instance to the cancel instance params
func (o *CancelInstanceParams) WithInstance(instance string) *CancelInstanceParams {
	o.SetInstance(instance)
	return o
}

// SetInstance adds the instance to the cancel instance params
func (o *CancelInstanceParams) SetInstance(instance string) {
	o.Instance = instance
}

// WithNamespace adds the namespace to the cancel instance params
func (o *CancelInstanceParams) WithNamespace(namespace string) *CancelInstanceParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the cancel instance params
func (o *CancelInstanceParams) SetNamespace(namespace string) {
	o.Namespace = namespace
}

// WriteToRequest writes these params to a swagger request
func (o *CancelInstanceParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param instance
	if err := r.SetPathParam("instance", o.Instance); err != nil {
		return err
	}

	// path param namespace
	if err := r.SetPathParam("namespace", o.Namespace); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
