// Code generated by go-swagger; DO NOT EDIT.

package registries

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"fmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// CreateGlobalRegistryReader is a Reader for the CreateGlobalRegistry structure.
type CreateGlobalRegistryReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *CreateGlobalRegistryReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewCreateGlobalRegistryOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewCreateGlobalRegistryOK creates a CreateGlobalRegistryOK with default headers values
func NewCreateGlobalRegistryOK() *CreateGlobalRegistryOK {
	return &CreateGlobalRegistryOK{}
}

/* CreateGlobalRegistryOK describes a response with status code 200, with default header values.

successfully created global registry
*/
type CreateGlobalRegistryOK struct {
}

func (o *CreateGlobalRegistryOK) Error() string {
	return fmt.Sprintf("[POST /api/functions/registries/global][%d] createGlobalRegistryOK ", 200)
}

func (o *CreateGlobalRegistryOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

/*CreateGlobalRegistryBody create global registry body
// Example: {"data":"admin:8QwFLg%D$qg*","reg":"https://prod.customreg.io"}
swagger:model CreateGlobalRegistryBody
*/
type CreateGlobalRegistryBody struct {

	// Target registry connection data containing the user and token.
	// Required: true
	Data *string `json:"data"`

	// Target registry URL
	// Required: true
	Reg *string `json:"reg"`
}

// Validate validates this create global registry body
func (o *CreateGlobalRegistryBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateData(formats); err != nil {
		res = append(res, err)
	}

	if err := o.validateReg(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *CreateGlobalRegistryBody) validateData(formats strfmt.Registry) error {

	if err := validate.Required("Registry Payload"+"."+"data", "body", o.Data); err != nil {
		return err
	}

	return nil
}

func (o *CreateGlobalRegistryBody) validateReg(formats strfmt.Registry) error {

	if err := validate.Required("Registry Payload"+"."+"reg", "body", o.Reg); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this create global registry body based on context it is used
func (o *CreateGlobalRegistryBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (o *CreateGlobalRegistryBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *CreateGlobalRegistryBody) UnmarshalBinary(b []byte) error {
	var res CreateGlobalRegistryBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
